%global gem_name hoe

Summary:    	Hoe is a simple rake/rubygems helper for project Rakefiles
Name:       	rubygem-%{gem_name}
Version:    	3.13.0
Release:    	%mkrel 1
Group:      	Development/Ruby
License:    	MIT
URL:        	http://rubyforge.org/projects/seattlerb/
Source0:    	http://rubygems.org/gems/%{gem_name}-%{version}.gem
Patch0:		rubygem-hoe-3.0.6-rescue-missing-Manifest.patch
Requires:	ruby(release)
BuildRequires:	ruby(release)
Requires:   	rubygems >= 1.3.6
Requires:   	rubygem(rake) >= 0.8.7
BuildRequires:  rubygems-devel >= 1.3.6
BuildRequires:	rubygem(minitest)
BuildRequires:	rubygem(rake)
BuildArch:  	noarch
Provides:   	rubygem(%{gem_name}) = %{version}

%description
Hoe is a rake/rubygems helper for project Rakefiles. It helps generate
rubygems and includes a dynamic plug-in system allowing for easy
extensibility. Hoe ships with plug-ins for all your usual project
tasks including rdoc generation, testing, packaging, and deployment.
Plug-ins Provided:
* Hoe::Clean
* Hoe::Debug
* Hoe::Deps
* Hoe::Flay
* Hoe::Flog
* Hoe::Inline
* Hoe::Package
* Hoe::Publish
* Hoe::RCov
* Hoe::Signing
* Hoe::Test
See class rdoc for help. Hint: ri Hoe

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%prep
%setup -q -c -T

# Gem repack
TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}

# Patches
%patch0 -p0

# Allow rake 0.9
sed -i \
	-e '/rake/s|~> 0\.8|>= 0.8.7|' \
	-e '/rake/s|< 11\.0|< 12\.0|' \
	lib/hoe.rb \
	Rakefile

# Allow RubyInline 3.8.4
sed -i -e '/RubyInline/s|~> 3\.9|>= 3.8.4|' \
	lib/hoe/inline.rb

# Allow rake-compiler 0.8.0 and above
sed -i -e '/rake-compiler/s|~> 0\.7|>= 0.7|' \
	lib/hoe/compiler.rb

# For old minitest
%if 0%{?fedora} < 21
sed -i -e 's|Mini[tT]est::Test|MiniTest::Unit::TestCase|' \
	test/test_hoe*.rb
%endif

gem specification -l --ruby %{SOURCE0} > %{gem_name}.gemspec

gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{_prefix}/* \
	%{buildroot}%{_prefix}/

chmod 0644 %{buildroot}%{gem_dir}/cache/*gem

find %{buildroot}/%{gem_instdir}/bin -type f | xargs chmod 0755
find %{buildroot}/%{_bindir} -type f | xargs chmod 0755

chmod 0755 %{buildroot}/%{gem_instdir}/template/bin/file_name.erb

%check
pushd .%{gem_instdir}

# ???
sed -i -e '/maglev\?/d' test/test_hoe_debug.rb

# Save original Rakefile
sed -i.isolate -e \
	'/Hoe\.plugin :isolate/d' Rakefile
# Make sure that hoe currently building are loaded
export RUBYLIB=$(pwd)/lib

rake test -v --trace

mv Rakefile{.isolate,}
popd

%files
%defattr(-, root, root, -)
%{_bindir}/sow
%dir %{gem_instdir}/
%{gem_instdir}/bin/
%{gem_instdir}/lib/
%{gem_instdir}/template/
%{gem_cache}
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_spec}
%doc %{gem_instdir}/[A-Z]*

%files	doc
%defattr(-,root,root,-)
%{gem_instdir}/.autotest
%{gem_instdir}/.gemtest
%{gem_instdir}/test/
%{gem_docdir}

%changelog
* Fri Oct 31 2014 bb <bb> 3.13.0-1pclos2014
- import
